// Quaternion.h: Schnittstelle fr die Klasse Quaternion
//
//////////////////////////////////////////////////////////////////////

#ifndef QUATERNION_H
#define QUATERNION_H

#define PI 3.141592654
#define GET_RADIANS(degree) (float)(degree / 180.0f * PI)

#include <math.h>
#include "Vector4.h"


class Quaternion 
{
	public:

		// constructors/destructors
		Quaternion();
		Quaternion(float xAxis, float yAxis, float zAxis, float wAxis);

		// operators
		void operator=(const Quaternion &q);
		Quaternion operator*(const Quaternion &q);
		Quaternion operator+(const Quaternion &q);

		// methods
		void CreateQuatFromAxis(Vector4 a, float radians);
		float Length();
		void Normal();

		Quaternion Conjugate();
		Quaternion CrossProduct(const Quaternion &q);

		void Rotatef(float amount, float xAxis, float yAxis, float zAxis);
		void RotationRadiansf(double X, double Y, double Z);
		void CreateMatrix(float *pMatrix);
		void Slerp(const Quaternion &q1, const Quaternion &q2, float t);

		// fields
		float x, y, z, w;
};

#endif